{
Hi everybody ...

Component: TPassWord 0.5 BETA

What does it do:
 1. takes a password, hashes it and saves the hash in the registry*
 2. can show a dialog for password entry and checks it
  or
    a checkfunction that takes the cleartext password

 *used registry entry:
 HKEY_what_you_like\Software\JoBerg\Components\PassWord\<application exe name>\<component name>

What can you do with it:
 Use it in a program to check a password

Limitations:
 You cannot(!) retrieve the password after hashing it.

Requires:
 DCPcrypt package by David Barton (davebarton@bigfoot.com),
 download at http://www.scramdisk.clara.net/delphi/

Thanks/Credits
 I want to say thanks to David Barton for his excellent crypto package,
 it saved me a lot of work and some algorithms I didn't even know before...

 Also thanks to my Grandparents who bought my version of Delphi 4.0 :-)

Contact information
 s-mail
  Johannes Berg
  Adlerweg 10
  D-32108 Bad Salzuflen
  GERMANY
 e-mail
  <johannes.berg@gmx.net>

 fon
  +49-(0)5222-20516 (will change within next 2 years)

 PGP-Key available on PGP-server,
 fingerprint: 3C62 9322 A66D E6B8 316A A18F 9592 8E9D CCF6 DFC6

VERSION OF TPassWord is 0.5 BETA
 I wrote this in one night, so use it if you like, tell me any bugs, but
 I do not say that its save to use!!!

Legal
 Use this package as you like, in any commercial or free-/share-/beer-/etc ware
 application, but give me credit for my component (in source code is fine, in
 the application is even better :-)).
 I cannot accept any responsibility for any damages, losses, etc. caused by
 this component.

Notes
 The password entry dialog is probably not safe!!!

 Anybody with knowledge of how this works can reset the password entry in
 the registry, so don't use it with sensitive data!

}


unit PassWord;
{$R pwd.res}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  haval, rmd160, sha1, dcpCrypt, passworddialog;

type
  tAlgoChoice = (algoHaval,algoRipeMD160,algoSHA1);
  tSaveWhere  = (saveRegistry);
  tHKEY       = (_Current_user,_local_machine);
  tPasswordReturn     = (passwordOK,passwordInvalid,passwordCancel,passwordError);

  TPassWord = class(TComponent)
  private
    { Private declarations }
    fAlgo: tAlgoChoice;
    fhashsize: word;
    fSaveWhere : tSaveWhere;
    fRootKey : HKEY;

    HashComponent : tDCP_Hash;

    Hash:string;

    function fGetSize:word;
    procedure fSetAlgo(value:tAlgoChoice);
    procedure fSetSize(value:word);
    function fGetRootKey:tHKEY;
    procedure fSetRootKey(value:tHKEY);

    procedure SaveHash;
    procedure LoadHash;
    function encodehash(cleartext:string):string;

  protected
    { Protected declarations }
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;

    procedure   SetPassword   (password:string);
    function    CheckPassword (password:string):boolean;
    function    CheckPasswordDialog(caption:string='Password';prompt:string='Enter password:') : tPasswordReturn;

  published
    { Published declarations }
    property algorithm : tAlgoChoice read fAlgo write fSetAlgo default algoHaval;
    property HashSize  : word read fGetSize write fSetSize default 256;
    property WhereToSaveHash: tSaveWhere read fSaveWhere write fSaveWhere;
    property RegistryRootKey : tHKEY read fGetRootKey write fSetRootKey;

  end;

procedure Register;

implementation
uses registry;

constructor tPassword.Create;
begin
 inherited create(aowner);
 HashSize:=256;
end;

function tPassword.encodehash;
begin
 case fAlgo of
  algoHaval: hashcomponent:=tDCP_haval.Create(self);
  algoRipeMD160: hashcomponent:=tDCP_rmd160.Create(self);
  algoSHA1:      hashcomponent:=tDCP_SHA1.Create(self);
 end;
  hashcomponent.Init;
  hashcomponent.HashSize:=fhashsize;
  hashcomponent.UpdateStr(cleartext);
  setlength(result,fhashsize div 8);
  hashcomponent.Final(result[1]);
  hashcomponent.free;
end;

procedure tPassWord.fSetRootKey;
begin
 case value of
  _current_user : frootkey:=hkey_current_user;
  _local_machine: frootkey:=hkey_local_machine;
 end;
end;

function tPassWord.fGetRootKey;
begin
 result:=_current_user;
 case frootkey of
  hkey_current_user: result:=_current_user;
  hkey_local_machine : result:=_local_machine;
 end;
end;

function tpassWord.fGetSize;
begin
 result:=0;
 case fAlgo of
  algoHaval     : result:=fHashSize;
  algoSha1      : result:=fHashSize;
  algoRipeMD160 : result:=fHashSize;
 end;
end;

procedure tPassWord.LoadHash;
var reg:tRegistry;
begin
 case fSaveWhere of
  saveRegistry: begin
                 reg:=tRegistry.Create;
                 reg.RootKey:=fRootKey;
                 reg.OpenKey('Software\JoBerg\Components\PassWord\'+extractfilename(paramstr(0)),true);
                 try
                  hash:=reg.ReadString(self.Name);
                 except
                  on eRegistryException do hash:=' ';
                 end;
                 reg.Free;
                 case hash[1] of
                  'H':begin
                       case hash[2] of
                        '1':fhashsize:=128;
                        '2':fhashsize:=160;
                        '3':fhashsize:=192;
                        '4':fhashsize:=224;
                        '5':fhashsize:=256;
                       end;
                       fAlgo:=algoHaval;
                       delete(hash,1,1);
                      end;
                  'S':fAlgo:=algoSHA1;
                  'R':fAlgo:=algoRIPEMD160;
                 end;
                 delete(hash,1,1);
                end;
 end;
end;

procedure tPassword.SaveHash;
var reg:tRegistry;
begin
 case fSaveWhere of
  saveRegistry: begin
                 reg:=tRegistry.Create;
                 reg.RootKey:=fRootKey;
                 reg.OpenKey('Software\JoBerg\Components\PassWord\'+extractfilename(paramstr(0)),true);
                 case fAlgo of
                  algoHaval: begin
                              case fhashsize of
                               128: hash:='1'+hash;
                               160: hash:='2'+hash;
                               192: hash:='3'+hash;
                               224: hash:='4'+hash;
                               256: hash:='5'+hash;
                              end;
                              hash:='H'+hash;
                             end;
                  algoSHA1: hash:='S'+hash;
                  algoRIPEMD160:hash:='R'+hash;
                 end;
                 reg.WriteString(self.Name,hash);
                 delete(hash,1,1);
                 if algoHaval = fAlgo then delete(hash,1,1); 
                 reg.Free;
                end;
 end;
end;

procedure tpassWord.fSetSize;
begin
 case fAlgo of
  algoHaval     : begin
                   if Value = fHashSize then
                                         Exit;
                   if Value<= 128 then
                                   fHashSize:= 128
                   else if Value<= 160 then
                                        fHashSize:= 160
                   else if Value<= 192 then
                                        fHashSize:= 192
                   else if Value<= 224 then
                                        fHashSize:= 224
                   else
                                        fHashSize:= 256;
                  end;
  algoSha1      : begin
                   fHashsize:=160;
                   if value <> 160 then showmessage('SHA1 only supports 160 bits');
                  end;
  algoRipeMD160 : begin
                   fHashsize:=160;
                   if value <> 160 then showmessage('RipeMD-160 only supports 160 bits');
                  end;
 end;
end;


procedure tPassWord.fSetAlgo;
begin
 fAlgo:=value;
 case value of
  algoHaval     : fHashSize:=256;
  algoSHA1      : fHashSize:=160;
  algoRipeMD160 : fHashSize:=160;
 end;
end;

procedure tPassWord.SetPassword;
begin
 hash:=encodehash(password);
 savehash;
end;

function tPassword.CheckPassword;
var temphash:string;
begin
 loadhash;
 temphash:=encodehash(password);
 result:=false;
 if temphash=hash then result:=true;
end;

procedure Register;
begin
  RegisterComponents('JMB', [TPassWord]);
end;

function tPassword.CheckPasswordDialog;
var pwdd:tpwddialog;
begin
 result:=passwordError;
 pwdd:=tpwddialog.Create(self);
 pwdd.lblprompt.caption:=prompt;
 pwdd.Caption:=caption;
 case pwdd.ShowModal of
  mrCancel : result:=passwordCancel;
  mrOK     : if checkpassword(pwdd.edtPassword.text) then result:=passwordOK
                                                     else result:=passwordInvalid;
 end;
 pwdd.edtPassword.Text:='';
 pwdd.free;
end;

end.
